unit UfrmMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin;

type
  TfrmMain = class(TForm)
    edtAmount: TEdit;
    edtPercentage: TEdit;
    edtQuantity: TSpinEdit;
    edtResult: TEdit;
    edtDigits: TSpinEdit;
    edtFormula: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure EditChange(Sender: TObject);
    procedure EditKeyPress(Sender: TObject; var Key: Char);
  private
    FFormatSettings: TFormatSettings;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

// Dit is, in de basis, de formule waarmee ik een probleem heb.
//
// Hij berekend alles zoals verwacht, maar toch denkt oa. Excel daar anders over.
// Het is de afronding waar het anders gaat: de formule geeft, afgerond naar currency
// 4 decimalen, 5.4950 en naar 2 decimalen is dat 5.50.
// Excel is echter van mening dat 5.4950 afgerond moet worden naar 5.49, terwijl,
// volgens mij, bij bankers rounding afgerond zou moeten worden naar het dichtbijzijnde
// integer even getal.
// Stap voor stap in Excel:
//            5,4949554 => 5,494955 => 5,49496 => 5,4950 => 5,495 => 5,49
//
// Wat zie ik verkeerd?
function CalcAmount(AChargeAmount: Currency; APercentage: Double; AQty: Integer): Currency;
begin
  Result := ((AChargeAmount / AQty) * (APercentage / 100)) * AQty;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  FFormatSettings := TFormatSettings.Create('nl-NL'); // Verander locale indien nodig (bijvoorbeeld 'en-US')

  edtAmount.Text     := FloatToStr(99, FFormatSettings);
  edtPercentage.Text := FloatToStr(5.55046, FFormatSettings);
  edtQuantity.Value  := 1;
end;

procedure TfrmMain.EditChange(Sender: TObject);
var
  cAmount: Currency;
  dPerc: Double;
begin
  if TryStrToCurr(edtAmount.Text, cAmount, FFormatSettings) and
     TryStrToFloat(edtPercentage.Text, dPerc, FFormatSettings) then
  begin
    edtResult.Text := CurrToStrF(CalcAmount(cAmount, dPerc, edtQuantity.Value),
                                 ffCurrency, edtDigits.Value, FFormatSettings);

    edtFormula.Text := Format('= ((%0:s / %2:d) * (%1:s / 100)) * %2:d',
                              [edtAmount.Text, edtPercentage.Text, edtQuantity.Value]);
  end
  else
  begin
    edtResult.Clear;
    edtFormula.Clear;
  end;
end;

procedure TfrmMain.EditKeyPress(Sender: TObject; var Key: Char);
begin
  case Key of
    '.', ',':
      if Pos('.', TEdit(Sender).Text) = 0 then
        Key := FFormatSettings.DecimalSeparator
      else
        Key := #0;
    #8,
    '0'..'9': ;
  else
    Key := #0;
  end;
end;

end.

